
#ifndef __UART_H__
#define __UART_H__

//#define COMSPI  1
//#define DEFAULT_BAUDRATE 			500000
#define DEFAULT_BAUDRATE 			115200
#define ERROR_TIMEOUT   3

#define Ux(y)         U2##y

#define UxBRG           Ux(BRG)
#define UxMODE          Ux(MODE)
#define UxSTA           Ux(STA)
#define UxSTAbits       Ux(STAbits)
#define UxSTACLR        Ux(STACLR)
#define UxSTASET        Ux(STASET)
#define UxTXREG         Ux(TXREG)
#define UxRXREG         Ux(RXREG)

#define TRANS_LAYER_Init UartInit
#define TRANS_LAYER_Task UartTask
#define TRANS_LAYER_Close UartClose

extern volatile int gnCntForComm;   // ʐM̑҂ԔpTimer2̊荞(0.1s)ƂɉZ
#define ResetCommCnt()   (gnCntForComm = 0)
#define IsCommCntOV()    (gnCntForComm >= ERROR_TIMEOUT*10)
#define IncCommCnt()    (gnCntForComm++)


#define _EOT    0x04
#define _STX    0x02
#define _ETX    0x03
#define _ENQ    0x05
#define _ACK    0x06
#define _BEL    0x07
#define _DLE    0x10
#define _DC1    0x11
#define _NAK    0x15
#define _CAN    0x18
#define _ESC    0x1b
#define _DEL    0x7f

#if 1
#define UARTClearAllErrors()  UART2ClearAllErrors()
#define CloseUART() CloseUART2()
#endif

#ifdef UART1
#define RXSetup()           ( do{ U1RXR = 4; TRISBbits.TRISB2 = 1;}while(0))      // U1RX , RB2, INPUT
#define TXSetup()           ( do{ RPB3R = 1; TRISBbits.TRISB3 = 0;}while(0))      // U1TX , RB3, Output
#define	isRXINT()			(IFS1bits.U1RXIF)
#define	isTXINT()			(IFS1bits.U1TXIF)
#define	RXINT_Clear()		(IFS1bits.U1RXIF=0)
#define	TXINT_Clear()		(IFS1bits.U1TXIF=0)
#define	isEnableRXINT()		(IEC1bits.U1RXIE)
#define	isEnableTXINT()		(IEC1bits.U1TXIE)
#define	EnableRXINT()		(IEC1bits.U1RXIE=1)
#define	EnableTXINT()		(IEC1bits.U1TXIE=1)
#define	DisableRXINT()		(IEC1bits.U1RXIE=0)
#define	DisableTXINT()		(IEC1bits.U1TXIE=0)
#define mUSetIntPriority(priority)       ( IPC9CLR = _IPC9_U1IP_MASK, IPC9SET = ((priority) << _IPC9_U1IP_POSITION))
#else
#define RXSetup()          do{ U2RXR = 2; TRISBbits.TRISB1 = 1;}while(0)      // U2RX , RB1, INPUT
#define TXSetup()           do{ RPB0R = 2; TRISBbits.TRISB0 = 0;}while(0)      // U2TX , RB0, Output
#define	isRXINT()			(IFS1bits.U2RXIF)
#define	isTXINT()			(IFS1bits.U2TXIF)
#define	RXINT_Clear()		(IFS1bits.U2RXIF=0)
#define	TXINT_Clear()		(IFS1bits.U2TXIF=0)
#define	isEnableRXINT()		(IEC1bits.U2RXIE)
#define	isEnableTXINT()		(IEC1bits.U2TXIE)
#define	EnableRXINT()		(IEC1bits.U2RXIE=1)
#define	EnableTXINT()		(IEC1bits.U2TXIE=1)
#define	DisableRXINT()		(IEC1bits.U2RXIE=0)
#define	DisableTXINT()		(IEC1bits.U2TXIE=0)
#define mUSetIntPriority(priority)       ( IPC9CLR = _IPC9_U2IP_MASK, IPC9SET = ((priority) << _IPC9_U2IP_POSITION))
#endif


#ifdef __cplusplus
extern "C" {
#endif
extern void TRANS_LAYER_Init(UINT);
extern void TRANS_LAYER_Task(void);
extern void UartClose(void);
#ifdef __cplusplus
}
#endif

#endif
