/* ************************************************************************** */
/** Descriptive File Name

  @Company
	Company Name

  @File Name
	filename.c

  @Summary
	Brief description of the file.

  @Description
	Describe the purpose of this file.
 */
/* ************************************************************************** */

/* ************************************************************************** */
/* ************************************************************************** */
/* Section: Included Files                                                    */
/* ************************************************************************** */
/* ************************************************************************** */
#include <xc.h>
#include <plib.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include "vardef.h"
#include "functions.h"
#include "Uart.h"
#include "NVMem.h"

void Delay10us(DWORD dwCount) {
	volatile DWORD _dcnt;

	_dcnt = dwCount * ((DWORD) (0.00001 / (1.0 / GetInstructionClock()) / 10));
	while (_dcnt--) {
#if defined(__C32__)
		Nop();
		Nop();
		Nop();
#endif
	}
}

void DelayMs(WORD ms) {
	unsigned char i;
	while (ms--) {
		i = 4;
		while (i--) {
			Delay10us(25);
		}
	}
}

void InitVars() {
	
	gIsRunning = 0;
	gnAliveCnt = 0; 
	gnTimer2Cnt = 0; 
	gn100msCnt = 0;
	gnTimer4Mode = 0;
	gninjstoppreiod = 0;
	gninjststartwait = 0;
	gninjststartangle = 0;
	gnignstoppreiod = 0;
	gnignstartwait = 0;
	gnignstartangle = 0;
	gnLastCPlusT2Val = 0;
	//gidledata
	//unsigned gadresult[ADSAMPLING_UNIT][8] = 0;
	gidxadresult = 0;
	groundtime = 0; 
	glastTDCtime = 0; 
	gIsInputCycle = 0; 
	gidxrpm = 0;
	gnanglenow = 0; 
	gCPlusOn = 0; 
	gOInjOn = 0; 
	gnOinjstoppreiod = 0; 
	gOIgnOn = 0; 
	gnOignstoppreiod = 0; 
	gac12Vresult = 0; 
	gADOkayBank = 0; 
	gErrorCode = 0; 
	gAccelVal = 0; 
	gVaccumVal = 0;
	gWaitInterupt = 0; 
	gnLastBTDC = 0; 
	gnAccelDelta = 0;
	gnKasokuAdd = 0; 
	gnKasokuSubVal = 0; 
	gnAccelPumpSpan = 0;
	gOInjEnter = 0;
	gOIgnEnter = 0;

}
//------------------------------@GW~ۂɂׂ

void EngineStop() {
	groundtime = 0;
	gIsRunning = 0; // GW~ƂAċN܂TIMER5͊荞܂Ȃ
	glastTDCtime = -1;
	gOInjOn = 0;
	gOIgnOn = 0;
	gCPlusOn = 0;
	gnKasokuAdd = 0;
	gninjstoppreiod = 0;
	gnignstoppreiod = 0;
	gnOinjstoppreiod = GetTCntFrom10usec(gsavedata.defInjSpan);
	gnLastBTDC = gsavedata.defBTDCFireVal;
	gnOignstoppreiod = GetTCntFrom10usec(gsavedata.defIgnSpan);
	gOInjEnter = 0;
	gOIgnEnter = 0;
}

//---------IC4 NNpXMŎg, 1]9M 30 x 9 90uN

void __ISR(_INPUT_CAPTURE_4_VECTOR, IPL5SOFT) IC4Interrupt(void) {
	static DWORD gnLastT2span[3];
	static int gnLastVaccVal;
	DWORD curTimer2, curSpan;

	mIC4ClearIntFlag();
	curTimer2 = IC4BUF;

	if (gCPlusOn) {
		curTimer2 += gnTimer2Cnt;

		curSpan = GetPassedTimeUL(curTimer2, gnLastCPlusT2Val);

		if (gIsRunning > _DEF_START_JUDGE_PULSCNT) // ~Ԃł͂ȂƂ(ŒłpXłȂƐfłȂ) 
		{
			gnanglenow++;
			// _̔
			if (curSpan > gnLastT2span[0] << 1) // ̎ԂO2{ƂA_ł̃pXƔf
			{
				gnanglenow = 0; // _Ƃ BDC _
				gnAliveCnt = 0; // GW]ƂƂŁAJE^NA

				if (glastTDCtime < 0) {
					groundtime = curSpan * 4; // 90x̌oߎԂ4{ĂP̎ԂƂ
				} else {
					groundtime = GetPassedTimeUL(curTimer2, glastTDCtime); // 1̎
				}

				glastTDCtime = curTimer2;
				
				//!!! ŁA݂zCœ_ΑOȂ̂A_ΌŋzCOȂ̂f
				if ( gOInjEnter )		// IWĩCWFN^[MON
				{
					gIsInputCycle = 1;
					gOInjEnter = 0;		// NA
				}
				else if (gOIgnEnter)
				{
					gIsInputCycle = 0;
					gOIgnEnter = 0;		// NA
				}
				else					// ɂ͓̂_ΐMːMJbgꂽꍇ
				{
					if(gVaccumVal != gnLastVaccVal)		// zCZT[ڑĂꍇ
						gIsInputCycle = (gVaccumVal < gnLastVaccVal); // zCZT[̓dlႢƂA͋zCƂȂ
					else
						gIsInputCycle = (gIsInputCycle + 1) & 1;	// gO
				}

				// ̃^C~OŌ݂̉]mA}bvQƃf[^Ƃ
				// ݂̉]e[ũCfNX 500rpmP = 0.12b̃JEg
				gidxrpm = WAIT100MS_SYSCLK * 12 / 10 / groundtime;
				if (gidxrpm > 23)
					gidxrpm = 23;

				// |v
				if (gsavedata.IsUseAccelPump && !gnKasokuAdd && gnAccelDelta > 0) {
					gnKasokuAdd = gnOinjstoppreiod * gecudata.TBL09_data[gnAccelDelta] / 1000;
					gnKasokuSubVal = gnKasokuAdd / gsavedata.nAccelPumpSpan;
					if (gnKasokuSubVal < 1)
						gnKasokuSubVal = 1;
				}


				int curAccelval = gadresult[gidxadresult][4]; // ANZlĂ
				int idxAccel = curAccelval / 13; // 20iKɂ
				// ˗ʂ_΂܂ł̎ԂvZ
				if(gIsInputCycle == 0)
				{
					// 񂪓_ΌA̋zĈ߂̐ݒl쐬
					int ibaseratio = gecudata.TBL02_data[idxAccel][gidxrpm]; // 0.1%P
					gninjstoppreiod = gnOinjstoppreiod * ibaseratio / 1000 + gnKasokuAdd;

					// zCoůJĂ^C~O͏㎀_牺_܂ł120x炢Ȃ̂ŁAJn^C~O𒲐
					// 0 
					gninjststartangle = 12 - gninjstoppreiod * 12 / groundtime; // _12ƂāA30xPʂɂ
					if (gninjststartangle > 7) // ۂɃouJn߂ʒułԂɍȂA
						gninjststartangle = 7;
					gninjststartwait = groundtime / 36; // 10xItZbg
				}
				else	
				{
					// 񂪋zC
					// _΂܂ł̑ҋ@ԂAgnLastBTDC̊pxɃe[ulĎԂ
					int nIgnAngle = gecudata.TBL03_data[idxAccel][gidxrpm] * 5; // 0.5xPʂ0.1xPʂɂ 
					nIgnAngle += gnLastBTDC; // BTDCł̊pxA0.1xP
					if (nIgnAngle < 300) {		// 30x̏ꍇA
						gnignstartangle = 5;
						gnignstartwait = (300 - nIgnAngle) * groundtime / 3600; // BTDC - 30 x̑҂
					} else {
						gnignstartangle = 4;
						gnignstartwait = (600 - nIgnAngle) * groundtime / 3600; // BTDC - 60 x̑҂
					}
					gnignstoppreiod = gnOignstoppreiod; // 
				}

			} 
			else // _ȊȌꍇ
			{
				if (!gsavedata.IsTunnelMode &&  gidxrpm >= _DEF_SWITCH_RPMIDX) {
					if (gnanglenow == gninjststartangle && !gIsInputCycle) // TDC ㎀_ + 30,ۂɋzC΂uJƂ
					{
						PR4 = gninjststartwait - 1; // ܂ŁA256SYSCLOCKȓȂ̂ŁA1ZxŐm
						TMR4 = 0;
						gnTimer4Mode = 1;
						mT4ClearIntFlag();
						mT4IntEnable(1);
					} 
					else if (gnanglenow == gnignstartangle && gIsInputCycle)
					{
						// _΂܂ł̃^C}lZbg
						PR4 = gnignstartwait - 1; // ܂ŁA256SYSCLOCKȓȂ̂ŁA1ZxŐm
						TMR4 = 0;
						gnTimer4Mode = 3;
						mT4ClearIntFlag();
						mT4IntEnable(1);
					}
				}
			}
		} else {
			gIsRunning++;
		}

		// [e[
		gnLastT2span[2] = gnLastT2span[1];
		gnLastT2span[1] = gnLastT2span[0];
		gnLastT2span[0] = curSpan;
		gnLastCPlusT2Val = curTimer2;
		gnLastVaccVal = gVaccumVal;
	} else {
		gCPlusOn = 1;
	}
}

//---------IC1 InjMĎAԊuv̂

void __ISR(_INPUT_CAPTURE_1_VECTOR, IPL4SOFT) IC1Interrupt(void) {
	static DWORD LastTimer2 = 0;
	DWORD curTimer2;

	CloseCapture1();
	if (gOInjOn) {
		if (gsavedata.IsTunnelMode)
			INJ_off();
		curTimer2 = IC1BUF;

		gnOinjstoppreiod = GetPassedTimeUL(curTimer2, LastTimer2);

		gWaitInterupt = 1;
		GoTimer1(WAIT1MS_SYSCLK);
	} else {
		if (gsavedata.IsTunnelMode || gidxrpm < _DEF_SWITCH_RPMIDX)
			INJ_on();
		LastTimer2 = IC1BUF; 
		gOInjOn = 1;
		gOInjEnter = 1;
		gWaitInterupt = 0;
		GoTimer1(WAIT1MS_SYSCLK);
	}
//	gerror += 30;
}

//---------IC3 COiC^[MĎAԊuv̂

void __ISR(_INPUT_CAPTURE_3_VECTOR, IPL4SOFT) IC3Interrupt(void) {
	DWORD curTimer2; //, npasstime, wk;
	static DWORD LastTimer2 = 0, LastCPTime, nLastPulseAngle;

	mIC3ClearIntFlag();
	CloseCapture3(); // 񂲂ƂɃLv`@\Xgbv

	if (gOIgnOn) {
//		CloseCapture3(); // FET̋tNdŊ荞݂̂h
		if (gsavedata.IsTunnelMode)
			IGN_off();

		gOIgnOn = 0;

		curTimer2 = IC3BUF;
		curTimer2 += gnTimer2Cnt;

		gnOignstoppreiod = GetPassedTimeUL(curTimer2, LastTimer2);

		gWaitInterupt = 3;
		GoTimer1(WAIT1MS_SYSCLK);

		// BTDC xȂ̂ 0.1xP

		// Ō̃NNpX̌oߎ
		//if(curTimer2 < gnLastCPlusT2Val)		
		//	npasstime = WAIT100MS_SYSCLK - gnLastCPlusT2Val + curTimer2;
		//else
		//	npasstime = curTimer2 - gnLastCPlusT2Val ;

		//// BTDC̊px́AʎԂZopxA_̌oߊpx(npasstime/groundtime*3600 + gnanglenow * 300)Z
		//gnLastBTDC = (gnOignstoppreiod - npasstime) * 3600 / groundtime - gnanglenow * 300;
		//gnanglenow + (npasstime - gnOignstoppreiod) * 12 / groundtime

		// nLastAngle == 4 Ȃ@60xO30xO܂ł̊Ԃɔ 5 Ȃ 300܂łɔ
		// oߎԂ̎ԂŊ360xΌoߊpxɂȂ̂łZ
		if (groundtime == 0)
			gnLastBTDC = 200;				// O΍pA20xŒƂ
		else								// NNp̌oߎԁ^1̎ * 360 = oߊpx
			gnLastBTDC = 600 - (nLastPulseAngle - 4) * 300 - LastCPTime * 3600 / groundtime;
	} else {
		// _ΐMANeBJ
		if (gsavedata.IsTunnelMode || gidxrpm < _DEF_SWITCH_RPMIDX)
			IGN_on();
		gOIgnOn = 1;
		gOIgnEnter = 1;
		LastTimer2 = IC3BUF; // FIFOobt@Ɋi[Ă
		LastTimer2 += gnTimer2Cnt;

		// ŌvZ鍀ڂݒ肵Ă(Ō̃NNp̌oߎ))
		LastCPTime = GetPassedTimeUL(LastTimer2, gnLastCPlusT2Val);
		nLastPulseAngle = gnanglenow; // ݂̃NNpޔĂ

		gWaitInterupt = 2;
		GoTimer1(WAIT1MS_SYSCLK);

	}
	gerror  += 2;
}

//---------Timer1, Vbg^C}[ƂāA~荞݂̂Ɏgp
//			IɁA1msȓŃCWFN^[COiC^[IIt邱Ƃ͂肦Ȃ̂
//			듮h~pɐM1msoߌɂ̃^C}CxgĂяoA̐Mo悤ɂĂ
void __ISR(_TIMER_1_VECTOR, IPL3SOFT) Timer1Interrupt(void) {
	volatile int dummy;
	mT1ClearIntFlag();
	mT1IntEnable(0); // 荞݂֎~
	switch (gWaitInterupt) {
		case 0:
			dummy = IC1BUF; // ̃f[^Lv`Ă\̂ŋɂ
			mIC1ClearIntFlag();
			mIC1IntEnable(1);
			IC1CONbits.FEDGE = 1;				// I[vhCȂ̂ŁARISEGbWŃIt
			IC1CONbits.ICM = IC_SP_EVERY_EDGE; // ĂуLv`Jn
			break;
		case 1:
			dummy = IC1BUF; // ̃f[^Lv`Ă\̂ŋɂ
			mIC1ClearIntFlag();
			mIC1IntEnable(1);
			IC1CONbits.FEDGE = IC_FEDGE_FALL;	// ̃Ioł悤ɂ邽߁AFALLGbWo
			IC1CONbits.ICM = IC_SP_EVERY_EDGE; // ĂуLv`Jn
			break;
		case 2:							// IGNMON
			dummy = IC3BUF;
			mIC3ClearIntFlag();
			mIC3IntEnable(1);
			IC3CONbits.FEDGE = 1;				// I[vhCȂ̂ŁARISEGbWŃIt
			IC3CONbits.ICM = IC_SP_EVERY_EDGE; // ĂуLv`Jn
			break;
		case 3:							// IGNMOFF
			dummy = IC3BUF;
			mIC3ClearIntFlag();
			mIC3IntEnable(1);
			IC3CONbits.FEDGE = IC_FEDGE_FALL;	// ̃Ioł悤ɂ邽߁AFALLGbWo
			IC3CONbits.ICM = IC_SP_EVERY_EDGE; // ĂуLv`Jn
			break;
	}
}

//---------Timer4, Vbg^C}[ƂāAR˂Ɠ_΂ŌĂяo

void __ISR(_TIMER_4_VECTOR, IPL5SOFT) Timer4Interrupt(void) {
	//mT5IntEnable(0);				// 荞݂֎~
	mT4ClearIntFlag();
	switch (gnTimer4Mode) {
		case 1: // INJECTER ON
			INJ_on();
			PR4 = gninjstoppreiod;
			break;
		case 2: // INJECTER OFF
			INJ_off();
			mT4IntEnable(0); // 荞݂֎~
			break;
		case 3: // IGNIGHTER ON
			IGN_on();
			PR4 = gnignstoppreiod;
			break;
		case 4: // IGNIGHTER OFF
			IGN_off();
			mT4IntEnable(0); // 荞݂֎~
			break;
	}
	gnTimer4Mode++;
}

//---------Timer2, 0.1bŊ荞. vWatchDogIȎgŁAGW~ȂǂɎg
//			25632rbgJE^ƁAől27487b, 7Ԍvł

void __ISR(_TIMER_2_VECTOR, IPL6SOFT) Timer2Interrupt(void) {
	mT2ClearIntFlag();
	gnTimer2Cnt += WAIT100MS_SYSCLK; // m32rbg^C}ƓӖɂ
	gn100msCnt++;
	gnAliveCnt++;
	IncCommCnt();

	if (gnAliveCnt > _DEF_ENGSTOP_100MSCNT && gIsRunning ) 
		EngineStop();

	if ((gnTimer2Cnt & 1) && gsavedata.IsUseAccelPump) {
		if (gnKasokuAdd) {
			gnKasokuAdd -= gnKasokuSubVal;
		} else
			CalcuDelta(); // 0.2bԂł̃ANZψڂŁA|vf
	}
    if (gerror)
          ShowErrorLED(gerror);
}

//---------ADConverter, 0.6mbŊ荞, ADϊʂ𖳌ɔzɊi[Ă̂

void __ISR(_ADC_VECTOR, IPL1SOFT) ADCInterrupt(void) {
	// AVDD ɂ5V番2.5V̂ƂBZT[̓͂ϓČv̂ƂB
	// ZT̍őŏl200?5K xƐA5K̒R5VցAZT[̐ɕtČvAd͂悻2.50ɕω\
	unsigned char *pdst = &gadresult[gidxadresult][0];
	mAD1ClearIntFlag();
	if (AD1CON2bits.BUFS == 1) {
		*pdst++ = (ADC1BUF0 >> 2); // O2
		*pdst++ = (ADC1BUF1 >> 2); // TEMP1
		*pdst++ = (ADC1BUF2 >> 2); // TEMP2
		gVaccumVal = ADC1BUF3; // VACCU
		*pdst++ = (gVaccumVal >> 2);
		//		*pdst++ =  (ADC1BUF4 >> 2);		// ACCEL
		gAccelVal = ADC1BUF4;
		*pdst++ = (UINT8) ((gAccelVal - gsavedata.naccelmin) * 255 / (gsavedata.naccelmax - gsavedata.naccelmin));
		gac12Vresult = (ADC1BUF5 >> 2); // V
	} else {
		*pdst++ = (ADC1BUF8 >> 2);
		*pdst++ = (ADC1BUF9 >> 2);
		*pdst++ = (ADC1BUFA >> 2);
		gVaccumVal = ADC1BUFB;
		*pdst++ = (gVaccumVal >> 2);
		//*pdst++ =  (ADC1BUFC >> 2);
		gAccelVal = ADC1BUFC;
		*pdst++ = (UINT8) ((gAccelVal - gsavedata.naccelmin) * 255 / (gsavedata.naccelmax - gsavedata.naccelmin));
		gac12Vresult = (ADC1BUFD >> 2);
	}

	*pdst++ = IsCPulsOn() ? 0xef : 0;
	*pdst++ = gOInjOn ? 0 : 0xef; // ON̏ꍇLowAOffȂHIƂ
	*pdst = gOIgnOn ? 0 : 0xef; // ON̏ꍇLowAOffȂHIƂ

	gidxadresult++;
	if (gidxadresult == ADSAMPLING_UNIT * 2) {
		if(gADOkayBank & 4)	{				// bank1bNĂƂ
			gidxadresult = ADSAMPLING_UNIT;		// ĂуoNQ̐擪ɖ߂Čv
		}
		else	{
			gidxadresult = 0;				// 擪ɖ߂ăoNP
			gADOkayBank = (gADOkayBank & 0x0c) | 2;		// 㔼̃e[u܂ bit2 ON
		}
	} else if (gidxadresult == ADSAMPLING_UNIT) {
		if(gADOkayBank & 8)	{				// bank2bNĂƂ
			gidxadresult = 0;				// ĂуoN1̐擪ɖ߂Čv
		}
		else	{
			gADOkayBank = (gADOkayBank & 0x0c) | 1;		// Õe[u܂ bit1 ON
		}
	}

}

void CalcuDelta() {
	static int lastAccelval = 0;
	int curAccelval = gadresult[gidxadresult][4]; // ANZlĂ
	int deltax = curAccelval - lastAccelval;
	if (deltax > 30) {
		deltax = (int) sqrt((double) deltax); // 16iKɕ␳
	} else
		deltax = 0;

	if (!gnKasokuAdd)
		gnAccelDelta = deltax;

	lastAccelval = curAccelval;
}

//--------------------------------------- WkFlush̍XV
#define PAGE_SIZE	1024

void UpdateWkFlush(int IsFlashEnable) {
	FLUSHWK buff;
	int *pflush = (int *) UDATA_WORK_ADDRESS,
			*pwk = (int *) &buff;
	int i;
	// ݂̏ޔĂ	
	for (i = 0; i < (sizeof (FLUSHWK) / sizeof (int)); i++)
		pwk[i] = pflush[i];
	buff.IsFlashEnable = IsFlashEnable;
	//@Yӏ
	NVMemErasePage(pflush); // 1024PʂŏȂ̂ŁA1񂾂ł̍\̕ɂȂ
	//	[hPʂŏ݂Ă
	pflush = (int *) PA_TO_KVA0(UDATA_WORK_ADDRESS);
	for (i = 0; i < (sizeof (FLUSHWK) / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], pwk[i]);
}

void UpdateUdata(PSAVEDATA pudata) {
	int *pflush = (int *) UDATA_FLASH_ADDRESS,
			*pwk = (int *) pudata;
	int i, j, ndata, nremain;
	UINT dummy = 0xffffffff;
	//@Yӏ
	for (i = 0; i < (SAVEDATA_SIZE / PAGE_SIZE); i++)
		NVMemErasePage(((void *) pflush) + i * PAGE_SIZE); // 

	ndata = sizeof (SAVEDATA);
	nremain = ndata & 3;
	ndata -= nremain;

	//	[hPʂŏ݂Ă
	pflush = (int *) PA_TO_KVA0(UDATA_FLASH_ADDRESS);
	for (i = 0; i < (ndata / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], pwk[i]);

	// 4bytẽoE_0xffŖ߂ď
	if (nremain) {
		for (j = 0; j < nremain; j++)
			((char *) &dummy)[j] = ((char *) pudata)[ndata + j];
		NVMemWriteWord(&pflush[i++], dummy);
	}

	// TCYɑȂOXFF
	dummy = 0xffffffff;
	for (; i < (SAVEDATA_SIZE / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], dummy);

}

void UpdateTable(int idxTbl, PALLTBL ptbldata) {
	int *pflush = (int *) (idxTbl == 0 ? TBL01_FLASH_ADDRESS : TBL01_FLASH_ADDRESS + ALLTBL_SIZE),
			*pwk = (int *) ptbldata;
	int i, j, ndata, nremain;
	UINT dummy = 0xffffffff;
	//@Yӏ
	for (i = 0; i < (ALLTBL_SIZE / PAGE_SIZE); i++)
		NVMemErasePage(((void *) pflush) + i * PAGE_SIZE); // 

	ndata = sizeof (ALLTBL);
	nremain = ndata & 3;
	ndata -= nremain;

	//	[hPʂŏ݂Ă
	pflush = (int *) PA_TO_KVA0(idxTbl == 0 ? TBL01_FLASH_ADDRESS : TBL01_FLASH_ADDRESS + ALLTBL_SIZE);
	for (i = 0; i < (ndata / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], pwk[i]);

	// 4bytẽoE_0xffŖ߂ď
	if (nremain) {
		for (j = 0; j < nremain; j++)
			((char *) &dummy)[j] = ((char *) ptbldata)[ndata + j];
		NVMemWriteWord(&pflush[i++], dummy);
	}

	// TCYɑȂOXFF
	dummy = 0xffffffff;
	for (; i < (ALLTBL_SIZE / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], dummy);

}

void UpdateFlush(void *paddr, size_t size, void *pdata) {
	int i, n;
	int *pflush = (int *) paddr, *pwk = (int *) pdata;

	for (i = 0; i < size; i += PAGE_SIZE)
		NVMemErasePage(paddr + i);
	size = ((size + 3) >> 2) << 2;
	for (i = 0; i < size / sizeof (int); i++)
		NVMemWriteWord(&pflush[i], pwk[i]);
}

//--------------------------------------- 臒l̃CfNX쐬
void RemakeThresholdsIdx() {
	int i, idxLast;
	// 臒le[uCfNX쐬(臒l16iK)
	for (i = 0, idxLast = 255; i < 16; i++) {
		int val = deftable.TBL04_range[i], j; // 
		for (j = val; j < idxLast; j++)
			gIdxTbls[2][j] = (UINT8) i;
		idxLast = val;
	}
	for (i = 0; i < idxLast; i++)
		gIdxTbls[2][i] = 0;
	for (i = 0, idxLast = 255; i < 16; i++) {
		int val = deftable.TBL05_range[i], j; // zCx
		for (j = val; j < idxLast; j++)
			gIdxTbls[3][j] = (UINT8) i;
		idxLast = val;
	}
	for (i = 0; i < idxLast; i++)
		gIdxTbls[3][i] = 0;
}
//--------------------------------------- ʐMC֐

void CommProcess() {
	UINT8 byte;
	UINT8 param[32], buff[2048 + 16], *ptr;
	int i;
	GetChar(&byte);
	switch (byte) {
		case _DC1: // mF(xؒfƁAȃf[^Ă܂̂ŁA̓d2~3񓊂邱Ƃňʒu킹ړI)
			PutChar(_ACK);
			break;
		case 'I': // IDLEJOB
#if 1			
		{
			int  i;
			unsigned char *pdst = &gadresult[gidxadresult][0];
			gidledata.rpm = (UINT8) GetRPMFromTmrVal(groundtime); //  100]Pʂɕ␳
			gidledata.inject_time = (UINT8) Get100usecFromTmrVal(gnOinjstoppreiod); // 1/10mbPʂɕ␳
			// ̒l͌vl̂܂ܓn
			gidledata.o2 = pdst[0]; // l̂܂0.01VP
			gidledata.temp1 = (char) (gIdxTbls[2][pdst[1]]); // -20 x10xP
			gidledata.temp2 = (char) (gIdxTbls[3][pdst[2]]);
			gidledata.accel = pdst[4];
			gidledata.volt = (UINT8) gac12Vresult; // 12V̓d, ő傪15Ƃ 15*̒l/256ŋ߂
			gidledata.btdcangle = (UINT8) (gnLastBTDC / 10); // pxAxP
			gidledata.errcode = gErrorCode;
			pdst = (UINT8 *) & gidledata;
			for (i = 0; i < 10; i++)
				PutChar(*pdst++);
		}
#endif		
			break;
		case 'M':
#if 1
		{
			unsigned char cTblNo, cX, cY, valh, vall;
			short sval;
			if (GetChar(&cTblNo) && GetChar(&cX) && GetChar(&cY) &&
					GetChar(&valh) && GetChar(&vall)) {
				sval = (short) ((unsigned)valh << 8 | vall);
				switch (cTblNo) {
					case 1:
						gecudata.TBL01_data[cY][cX] = sval;
						break;
					case 2:
						gecudata.TBL02_data[cY][cX] = sval;
						break;
					case 3:
						gecudata.TBL03_data[cY][cX] = sval;
						break;
					case 4:
						gecudata.TBL04_data[cY & 0x0f] = sval;
						break;
					case 5:
						gecudata.TBL05_data[cY & 0x0f] = sval;
						break;
					case 6:
						gecudata.TBL06_data[cY & 0x0f] = sval;
						break;
					case 7:
						gecudata.TBL07_data[cY & 0x0f] = sval;
						break;
					case 9:
						gecudata.TBL09_data[cY & 0x0f] = sval;
						break;
					case 11:
						gecudata.TBL01_range[cY & 0x0f] = sval;
						break;
					case 41:
						gecudata.TBL04_range[cY & 0x0f] = sval;
						break;
					case 51:
						gecudata.TBL05_range[cY & 0x0f] = sval;
						break;
				}
				PutChar(_ACK);
			} else
				PutChar(_NAK);
		}
#endif		
			break;
		case 'u': // PGMXV,WKtbV̈̃tOۑăZbg
#if 1
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			PutChar(_ACK);
			DelayMs(10);
			TRANS_LAYER_Close();
			UpdateWkFlush(1);
			DelayMs(10);
			SoftReset();
		}
#endif		
			break;
		case 'U': // MAPt@CۂƃAbv[h
#if 1			
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			for (i = 0;; i++) {
				if (!GetChar(&byte)) {
					PutChar(_NAK);
					return;
				}
				if ((param[i] = byte) == _ETX)
					break;
			}
			param[i] = 0;
			if (param[0] != '0' || !(param[1] == '2' || param[1] == '3')) {
				PutChar(_NAK);
				return;
			}
			PutChar(_ACK);
			ptr = (UINT8*) & gecudata;
			// Pʖ16ioCiɕϊăe[ũAhXɏł
			while (1) {
				int  nget = 0;
				for(nget = 0, byte = 0; nget < _DEF_SEND_BYTE_UNIT && byte != _EOT; nget++)
				{
					if (!GetChar(&byte)) {
						PutChar(_NAK);
						return;
					}
					buff[nget] = byte;
				}
				//EOT͖AKoCgȂ̂ŋɂ
				nget &= (~1);
				hextobin(ptr, &buff[0], nget);
				ptr += (nget / 2);
			}
			ptr = (UINT8*) TBL01_FLASH_ADDRESS + ALLTBL_SIZE * (param[1] == '2' ? 0 : 1);
			UpdateFlush(ptr, sizeof (ALLTBL), &gecudata);
			PutChar(_ACK);
		}
#endif		
			break;
		case 'D': // MAP_E[h
#if 1			
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			for (i = 0;; i++) {
				if (!GetChar(&byte)) {
					PutChar(_NAK);
					return;
				}
				if ((param[i] = byte) == _ETX)
					break;
			}
			param[i] = 0;
			if (param[0] != '0' || !(param[1] == '2' || param[1] == '3')) {
				PutChar(_NAK);
				return;
			}
			PutChar(_ACK);
			ptr = (UINT8*) TBL01_FLASH_ADDRESS + ALLTBL_SIZE * (param[1] == '2' ? 0 : 1);
			for (i = 0; i < ALLTBL_SIZE;) {
				int j;
				int nlen = ALLTBL_SIZE - i > _DEF_SEND_BIN_SIZE ? _DEF_SEND_BIN_SIZE : ALLTBL_SIZE - i;
				bintohex(buff, &ptr[i], nlen);
				for (j = 0; j < _DEF_SEND_BYTE_UNIT; j++)
				{
					PutChar(buff[j]);
				}
				i += nlen;
				if(nlen < _DEF_SEND_BIN_SIZE)
					break;					// f[^̏IӖ̂Ń[vI
				if (!GetChar(&byte)) {		// ẍׂɂĂ݂
					PutChar(_NAK);
					return;
				}
			}
			PutChar(_EOT);
		}
#endif		
			break;
		case 'A':
#if 1			
		{
			volatile int  remain, remain1, j;
			UINT8 *pdst;	
			if (gADOkayBank == 0)
			{
				PutChar(_NAK);
				return;
			}
			gADOkayBank |= (gADOkayBank << 2);	// bN(gp\BANKƓbNrbgIɂ )
			pdst = &gadresult[(gADOkayBank & 1) ? 0 : ADSAMPLING_UNIT  ][0];
			PutChar(_ACK);
			remain = ADSAMPLINGBYTES;
			i = 0;
			while(remain)
			{
				remain1  = remain < 256 ? remain : 256;
//				remain1  = remain < 128 ? remain : 128;
//				bintohex(buff, &pdst[i], remain1);
				remain -= remain1;
//				i += remain1;
//				remain1 *= 2;
				for(j = 0; j < remain1  ; j++)
				{
					PutChar(pdst[i++]);
//					PutChar(buff[j]);
				}
				GetChar(&byte);
			}
			gADOkayBank &= (3);					// bN
		}
#endif
			break;
		case 'd': // [U[f[^擾
#if 1			
		{
			char *psrc = (char *) &gsavedata;
			PutChar(_ACK);
			for (i = 0; i < sizeof (SAVEDATA);) {
				int j, nlen = sizeof (SAVEDATA) - i > 128 ? 128 : sizeof (SAVEDATA) - i;
				bintohex(buff, &psrc[i], nlen);
				for (j = 0; j < nlen * 2; j++)
					PutChar(buff[j]);
				i += nlen;
			}
			PutChar(_EOT);

		}
#endif		
			break;
		case 'c': //@[U[f[^ݒ
#if 1			
		{
			char *psrc = (char *) &gsavedata;
			PutChar(_ACK);
			i = 0;
			while (1) {
				if (!GetChar(&byte)) {
					PutChar(_NAK);
					return;
				}
				if ((buff[i] = byte) == _EOT)
					break;
				i++;
				if (i >= 256) {
					hextobin(psrc, &buff[0], 256);
					psrc += 128;
					i = 0;
				}
			}
			i &= ~1;
			if (i > 0)
				hextobin(psrc, &buff[0], i);

			UpdateUdata(&gsavedata);
			PutChar(_ACK);
		}
#endif		
			break;
		case 'm':
#if 1
		{
			unsigned char cTblNo, cX, cY, valh, vall;
			short sval;
			if (GetChar(&cTblNo) && GetChar(&cX) && GetChar(&cY)) {
				switch (cTblNo) {
					case 1:
						sval = gecudata.TBL01_data[cX][cY];
						break;
					case 2:
						sval = gecudata.TBL02_data[cX][cY];
						break;
					case 3:
						sval = gecudata.TBL03_data[cX][cY];
						break;
					case 4:
						sval = gecudata.TBL04_data[cX & 0x0f];
						break;
					case 5:
						sval = gecudata.TBL05_data[cX & 0x0f];
						break;
					case 6:
						sval = gecudata.TBL06_data[cX & 0x0f];
						break;
					case 7:
						sval = gecudata.TBL07_data[cX & 0x0f];
						break;
					case 9:
						sval = gecudata.TBL09_data[cX & 0x0f];
						break;
					case 11:
						sval = gecudata.TBL01_range[cX & 0x0f];
						break;
					case 41:
						sval = gecudata.TBL04_range[cX & 0x0f];
						break;
					case 51:
						sval = gecudata.TBL05_range[cX & 0x0f];
						break;
				}
				PutChar(_ACK);
				PutChar((sval >> 8) & 0xff);
				PutChar(sval && 0xff);
			} else
				PutChar(_NAK);
		}
#endif		
			break;
		case 'S': // e[utbV֏
#if 1
		{
			char tblno;
			GetChar(&tblno);
			if (tblno > 2) tblno -= 0x30;
			tblno -= 1;
			UpdateTable(tblno == 0 ? 0 : 1, &gecudata);
			PutChar(_ACK);
		}
#endif		
			break;
		case 't':
#if 1
		{
			unsigned char cTblNo;
			int nsizel;
			char *ptbl, *pnum;
			if (GetChar(&cTblNo) ) {
				switch (cTblNo) {
					case 1:
						ptbl = (char *)&gecudata.TBL01_data[0][0];
						nsizel = sizeof(gecudata.TBL01_data);
						break;
					case 2:
						ptbl = (char *)&gecudata.TBL02_data[0][0];
						nsizel = sizeof(gecudata.TBL02_data);
						break;
					case 3:
						ptbl = (char *)&gecudata.TBL03_data[0][0];
						nsizel = sizeof(gecudata.TBL03_data);
						break;
					case 4:
						ptbl = (char *)&gecudata.TBL04_data[0];
						nsizel = sizeof(gecudata.TBL04_data);
						break;
					case 5:
						ptbl = (char *)&gecudata.TBL05_data[0];
						nsizel = sizeof(gecudata.TBL05_data);
						break;
					case 6:
						ptbl = (char *)&gecudata.TBL06_data[0];
						nsizel = sizeof(gecudata.TBL06_data);
						break;
					case 7:
						ptbl = (char *)&gecudata.TBL07_data[0];
						nsizel = sizeof(gecudata.TBL07_data);
						break;
					case 9:
						ptbl = (char *)&gecudata.TBL09_data[0];
						nsizel = sizeof(gecudata.TBL09_data);
						break;
					case 11:
						ptbl = (char *)&gecudata.TBL01_range[0];
						nsizel = sizeof(gecudata.TBL01_range);
						break;
					case 41:
						ptbl = (char *)&gecudata.TBL04_range[0];
						nsizel = sizeof(gecudata.TBL04_range);
						break;
					case 51:
						ptbl = (char *)&gecudata.TBL05_range[0];
						nsizel = sizeof(gecudata.TBL05_range);
						break;
				}
				
				PutChar(_ACK);
				pnum = (char *)&nsizel;		// TCYM
				bintohex(buff, ptbl, nsizel);
				nsizel *= 2;
				for(i = 0; i < nsizel; i++) 
				{
					PutChar(buff[i]);
					//PutChar(0xfe);
				}
				PutChar(_EOT);
			} else
				PutChar(_NAK);
		}
#endif		
			break;
		case 'a': // Xbgŏl
#if 1
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			gsavedata.naccelmin = gAccelVal;
			UpdateUdata(&gsavedata);
			PutChar(_ACK);
		}
		break;
#endif		
		case 'b': // Xbgől
#if 1
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			gsavedata.naccelmax = gAccelVal;
			UpdateUdata(&gsavedata);
			PutChar(_ACK);
		}
		break;
#endif		
		case 'f': // Xbgl
#if 1
		{
			PutChar((UINT8)((gAccelVal >> 8) & 0xff));
			PutChar((UINT8)(gAccelVal & 0xff));
		}
			break;
#endif		
		case 'x':	// eXgp, x̌2oCgŋ̓IȃeXgeƂ
#if 1
		{
			UINT8  cmd1, cmd2;
			if (GetChar(&cmd1) && GetChar(&cmd2)) 
			{
				if (gIsRunning) // ss
				{
					PutChar(_NAK);
					break;
				}
				cmd2 -= 0x30;

				if(cmd1 == 'F')		// fet ̃`FbN
				{
					if(cmd2 & 1)
						IGN_on();
					else
						IGN_off();
					if(cmd2 & 2)
						INJ_on();
					else
						INJ_off();
				}
				else if (cmd1 == 'L')
				{
					if(cmd2)	led1_on();
					else		led1_off();
				}
			}
			PutChar(_ACK);
		}
#endif
			break;
		default:
			PutChar(_NAK);
			break;
	}

}

void hextobin(void *pdest, char *psrc, int nlen) {
	int i;
	char b1, b2;
	nlen = (nlen & ~1);
	for (i = 0; i < nlen; i += 2) {
		b1 = psrc[i] - 0x30;
		if (b1 > 9) b1 -= 7;
		b2 = psrc[i + 1] - 0x30;
		if (b2 > 9) b2 -= 7;
		((char *) pdest)[i >> 1] = (b1 << 4) | b2;
	}
}

void bintohex(char *pdest, void *psrc, int nlen) {
	int i, j;
	unsigned char b1, b2;
	nlen = (nlen & ~1);
	for (i = 0, j = 0; i < nlen; i++) {
		b1 = (((char*) psrc)[i] >> 4) & 0x0f;
		b2 = ((char*) psrc)[i] & 0x0f;
		pdest[j++] = (char) (b1 > 9 ? b1 + 0x37 : b1 + 0x30);
		pdest[j++] = (char) (b2 > 9 ? b2 + 0x37 : b2 + 0x30);
	}
}

//-------------------------------------------------------------------
//  G[R[hɑΉLED_ł郋[`
//	TSPAN_MY1SCOUNT1b̃[vƂĕ\
//	100̌0.25bA10̌0.5bA1̌1bɓ_ł悤ɂȂ
//  15Ȃ Z_1A_5
//-------------------------------------------------------------------
void ShowErrorLED(int nError)
{
#define __LEDON()	led1_on()
#define __LEDOFF()	led1_off()
#define TSPAN_MY1SCOUNT  8
#define TSPAN_2DIV 4
#define TSPAN_4DIV 2
#define TSPAN_8DIV 1
#define TSPAN_1DIV 8
	// 3f = 1s, 1f = 0.5s, f = 0.25s
    static  int savError = 0, nextError = 0;
    static  char    k100 = 0, k10 = 0, k1 = 0, bRepat = 0,  bOn = 0;
    static  int     nCnt = 0, kwait = 0;
    
//    if(!nError)
//    {
//        if(nError != savError)
//            __LEDOFF();
//        return;
//    }
    if(nextError != savError || bRepat)
    {
        savError = nextError;
        __LEDOFF();
        nCnt = 0;
		bOn = 0;
        bRepat = 0;
        k100 = (char)(nError / 100);
        k10 = (char)((nError - (k100 * 100) ) / 10);
        k1 = nError % 10;
        kwait = TSPAN_MY1SCOUNT * 2;
    }
    nCnt++;
    if(k100)
    {
        if((nCnt % TSPAN_4DIV) <= TSPAN_8DIV)
            __LEDOFF();
        else
            __LEDON();
        if(!(nCnt % TSPAN_4DIV))
		{
			nCnt = 0;
            k100--;
		}
        return;
    }
    if(k10)
    {
        if((nCnt % TSPAN_2DIV) <= TSPAN_4DIV)
            __LEDOFF();
        else
            __LEDON();
        if(!(nCnt % TSPAN_2DIV))
		{
			nCnt = 0;
            k10--;
		}
        return;
    }
    
    if(k1)
    {
		if(!bOn)
		{
			__LEDOFF();
		}
		else
		{
			__LEDON();
		}
		if((nCnt % TSPAN_1DIV) == 0)
		{
			bOn = (bOn + 1) & 1;
			if(!bOn)
				 k1--;
		}
        return;
    }
    
    if(kwait)
    {
       __LEDOFF();
       kwait --;
    }
    
    if (kwait < 1)
    {
		nextError = nError;				// \Ƃ܂
        bRepat = 1;
    }
}

/* *****************************************************************************
 End of File
 */

void encodeb64( char *lpszDest, char *lpszOrg, int nlen)
{
	static const  char base64_enc_map[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

	int i = 0, iR = 0;

    while(nlen)
	{
        lpszDest[iR] = base64_enc_map[(lpszOrg[i]) >> 2];
        if (nlen == 1) {
            lpszDest[iR + 1] = base64_enc_map[((lpszOrg[i] & 0x3) << 4) ];
            lpszDest[iR + 2] = '=';
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 1] = base64_enc_map[((lpszOrg[i] & 0x3) << 4) + ((lpszOrg[i + 1]) >> 4)];
        if (nlen == 2) {
            lpszDest[iR + 2] = base64_enc_map[(lpszOrg[i + 1] & 0xf) << 2];
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 2] = base64_enc_map[((lpszOrg[i + 1] & 0xf) << 2) + ((lpszOrg[i + 2]) >> 6)];
        lpszDest[iR + 3] = base64_enc_map[lpszOrg[i + 2] & 0x3f];
        lpszDest[iR + 4] = '\0';
		nlen -= 3;
        i += 3;
        iR += 4;
    }
    return;
}

int  decodeb64(char *lpszResult, char *lpszStr)
{
	static const  char base64_dec_map[128] =
	{
		127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
		127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
		127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
		127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
		127, 127, 127,  62, 127, 127, 127,  63,  52,  53,
		 54,  55,  56,  57,  58,  59,  60,  61, 127, 127,
		127,  64, 127, 127, 127,   0,   1,   2,   3,   4,
		  5,   6,   7,   8,   9,  10,  11,  12,  13,  14,
		 15,  16,  17,  18,  19,  20,  21,  22,  23,  24,
		 25, 127, 127, 127, 127, 127, 127,  26,  27,  28,
		 29,  30,  31,  32,  33,  34,  35,  36,  37,  38,
		 39,  40,  41,  42,  43,  44,  45,  46,  47,  48,
		 49,  50,  51, 127, 127, 127, 127, 127
	};
	int len, i, iR;
    char a1, a2, a3, a4;

    len = strlen(lpszStr);
    i = 0;
    iR = 0;
    while (i < len) {
        a1 = base64_dec_map[lpszStr[i++]];
        a2 = base64_dec_map[lpszStr[i++]];
        lpszResult[iR++] = (a1 << 2) + (a2 >>4);
		if(lpszStr[i] == '=')
			return iR;
        a3 = base64_dec_map[lpszStr[i++]];
        lpszResult[iR++] = (a2 << 4) + (a3 >>2);
		if(lpszStr[i] == '=')
			return iR;
        a4 = base64_dec_map[lpszStr[i++]];
        lpszResult[iR++] = (a3 << 6) + a4;
    }
    return iR;
}

