/* ************************************************************************** */
/** Descriptive File Name

  @Company
    Company Name

  @File Name
    filename.h

  @Summary
    Brief description of the file.

  @Description
    Describe the purpose of this file.
 */
/* ************************************************************************** */
#include <xc.h>
#include <plib.h>
#ifndef _FUNCTIONS_H    /* Guard against multiple inclusion */
#define _FUNCTIONS_H

#define GoTimer1(a) do { TMR1 = 0; mT1ClearIntFlag(); PR1=a; mT1IntEnable(1);	 } while(0);
#define GetPassedTime(now, last, max) (now < last ? max - last + now : now - last )
#define GetPassedTimeUL(now, last) GetPassedTime(now, last, 0xffffffffU)

/* Provide C++ Compatibility */
#ifdef __cplusplus
extern "C" {
#endif
    /* Provide C++ Compatibility */
void Delay10us(DWORD dwCount);
void DelayMs(WORD ms);
void EngineStop();  
void CommProcess();
void UpdateWkFlush(int IsFlashEnable) ;
void UpdateUdata(PSAVEDATA) ;
void UpdateTable(int idxTbl, PALLTBL) ;
void RemakeThresholdsIdx();
void CalcuDelta();
void hextobin(void *pdest, char *psrc, int nlen);
void bintohex(char *pdest, void *psrc, int nlen);
void InitVars();
void encodeb64( char *lpszDest, char *lpszOrg, int nlen);
int  decodeb64(char *lpszResult, char *lpszStr); 
#ifdef __cplusplus
}
#endif

#endif /* _FUNCTIONS_H */

/* *****************************************************************************
 End of File
 */
