/* ************************************************************************** */
/** Descriptive File Name

  @Company
    Company Name

  @File Name
    filename.h

  @Summary
    Brief description of the file.

  @Description
    Describe the purpose of this file.
 */
/* ************************************************************************** */
#include <xc.h>
//#include <plib.h>

#ifndef _VARDEF_H    /* Guard against multiple inclusion */
#define _VARDEF_H


/* ************************************************************************** */
/* ************************************************************************** */
/* Section: Included Files                                                    */
/* ************************************************************************** */
/* ************************************************************************** */

/* This section lists the other files that are included in this file.
 */

/* TODO:  Include other files here if needed. */


/* Provide C++ Compatibility */
#ifdef __cplusplus
extern "C" {
#endif

//---------- n[hEFAˑ̒`   
    
#define SYS_FREQ (40000000L)
#define GetSystemClock()    (SYS_FREQ)
#define GetInstructionClock()       GetSystemClock()
#define BlinkLED() (LATBbits.LATB7 = (PORTBbits.RB7 != 1))
#define InitLED() do{TRISBbits.TRISB7 = 0; LATBbits.LATB7= 1;}while(0)
#define led1_on()	(LATBbits.LATB7 = 0)
#define led1_off()	(LATBbits.LATB7 = 1)
    
#define INJ_setup() do{TRISBbits.TRISB9 = 0; LATBbits.TRISB9= 0;}while(0)  
#define INJ_on()    (LATBbits.LATB9 = 0)
#define INJ_off()    (LATBbits.LATB9 = 1)

#define IGN_setup() do{TRISBbits.TRISB8 = 0; LATBbits.TRISB8= 0;}while(0)  
#define IGN_on()    (LATBbits.LATB8 = 0)
#define IGN_off()    (LATBbits.LATB8 = 1)
    
#define MTR1_setup()    do{TRISBbits.TRISB13 = 0; LATBbits.TRISB13= 0;}while(0)  
#define MTR2_setup()    do{TRISBbits.TRISB12 = 0; LATBbits.TRISB12= 0;}while(0)  
#define MTR1_LO()   ( LATBbits.LATB13= 0)
#define MTR1_HI()   ( LATBbits.LATB13= 1)
#define MTR2_LO()   ( LATBbits.LATB10= 0)
#define MTR2_HI()   ( LATBbits.LATB10= 1)

#define UDATA_FLASH_ADDRESS         0x9D004000      // ̃vOŎgpłtbV̈̐擪
#define UDATA_WORK_ADDRESS			(UDATA_FLASH_ADDRESS + 0x0400)
#define TBL01_FLASH_ADDRESS         (UDATA_WORK_ADDRESS + 0x400)        // 
#define UDATA_WORK_SIZE				(sizeof(FLUSHWK))
    
#define UDATA_FLASH_END_ADDRESS   (0x9D004000 + 0x2000)

#define TMR_PRESCL  256         // ^C}[256    
#define WAIT100MS_SYSCLK   (SYS_FREQ/TMR_PRESCL/10-1)      // 0.1b̃^C}JEgl, 0x3d08  
#define WAIT100US_SYSCLK   (SYS_FREQ/TMR_PRESCL/10000-1)      // 0.1~b̃^C}JEgl, 15  
#define WAIT1MS_SYSCLK   (SYS_FREQ/TMR_PRESCL/1000-1)      // 1~b̃^C}JEgl, 156  
//#define Get10usecFromTmrVal(a)  (SYS_FREQ / 100000 * a /TMR_PRESCL)  // ̃JE^l1/100~bPʂł
#define Get10usecFromTmrVal(a)  (a * 10000 / WAIT100MS_SYSCLK)  // ̃JE^l1/100~bPʂł
#define Get100usecFromTmrVal(a)  (a * 1000 / WAIT100MS_SYSCLK)  // ̃JE^l1/10~bPʂł
#define GetTCntFrom10usec(a)    (a * WAIT100MS_SYSCLK / 10000)  // 1/100~bJE^lł
#define MINCOUNTMAXP100()       (SYS_FREQ/TMR_PRESCL*6/10)
#define GetRPMFromTmrVal(a)     (!a ? 0 : MINCOUNTMAXP100() / a) // ꕪ̑^C}JEg/100/1]̃JEg
//---------- \̂Ȃ    

//---------- ECUe[u`   
//          TuRƂĎgp̂TBL02TBL03̂݁B]ƃXbgł̕ˑʌWA܂͐ipvXl
    
#define ALLTBL_SIZE       3072       // 3K,@`ĂȂfillerƂ
typedef struct _ALLTBL
{
    short TBL01_data[16][24];       // Vaccum x RPM table
    short TBL01_range[16];          // Vaccum 臒l
    short TBL02_data[20][24];       // Accel x RPM table, 0.1%P
 //   short TBL02_range[16];          // Accel 臒l
    char  TBL03_data[20][24];       // Accel x RPM table, ip@vX}CiX0.5xP
    short TBL04_data[16];           // Water Temp
    short TBL04_range[16];          // Temp 臒l
    short TBL05_data[16];           // Air Temp
    short TBL05_range[16];          // Temp 臒l
    short TBL06_data[16];           // O2 table
    short TBL07_data[16];           // VOLTAGE
    short TBL09_data[16];           // Accel Pump   , 0.1%P
    //<--- to 1440 byte to here
    struct _TBL08{
        char    password[16];
        char    filler[384];
    } TBL08;
}ALLTBL, *PALLTBL;

//------------------------------------ [U[f[^ƂāAFLUSHɕۑf[^
#define SAVEDATA_SIZE       1024        // 1K,@`ĂȂfillerƂ
typedef  struct  _SAVEDATA {
    int verifysign1;                    // ǂpɎgpA0xffffffff Ȃ疢
    int ncurrent;                       // ݂̃e[uԍAftHg0Ƃ(0 or 1)
    int naccelmin;                      // ANZZT[̓dŏl
    int naccelmax;                      // ANZZT[̓dől
    int verifysign2;                    // ǂpɎgpA0xffffffff Ȃ疢
    int defBTDCFireVal;                 // ftHg̐ipxA0.1xPʁBftHg 200ɂ邩
    int defInjSpan;                     // ftHg̕ˎԁA1/100~bP ftHg 400
    int defIgnSpan;                     // ftHgIGNʓdԁA1/100~bP ftHg 640
    int IsUseAccelPump;                 // |v@\AftHgIt
    int nAccelPumpSpan;                 // |vʎԁA0.1bP, ftHg30
    int IsTunnelMode;                   // gl[hBM̂܂܍ČāAm[}Ɠɂ
}SAVEDATA, *PSAVEDATA;

//-------------- u[g[_Ɩ{̂ŏ񋤗Lׂ̈ɕێtbV̈̃f[^\
typedef struct _FLUSHWK
{
	int		IsFlashEnable;
	//---->	Add Here
	//<----
	UINT8	filler[0x400 - sizeof(int)];	// S1KoCgł
}FLUSHWK, *PFLUSHWK;

typedef struct _IDLEDATA {
    unsigned char volt;         // d
    unsigned char rpm;          //]
    unsigned char accel;        //ANZ
    char temp1;                 //TEMP1
    char temp2;                 //TEMP2
    unsigned char o2;           //O2
    unsigned char inject_time;  //ˎ
    unsigned char btdcangle;    //ipx
    unsigned char filler;       //
    unsigned char errcode;      //G[R[h
}IDLEDATA , *PIDLEDATA;

//-----------------------------------------------@萔AENUM
enum    enErrorCode { EC_NOERROR = 0, EC_VOLTAGELO, EC_NOCOM  };
#define _DEF_ENGSTOP_100MSCNT   5       // ̐l100~b̊ԁApXȂ΃GW~
#define _DEF_START_JUDGE_PULSCNT    5   // ̉񐔂̃pXΉ]JnƔf
#define _DEF_SWITCH_RPMIDX  6           // 500 x 6 = 3000 ]Ő؂ւ
#define _DEF_SEND_BYTE_UNIT     256     // xɓdMłTCY(16ix[X)
#define _DEF_SEND_BIN_SIZE      (_DEF_SEND_BYTE_UNIT / 2)   // oCix[XœdMł(16i1oCgɑ΂2ɂȂ̂ŔƂȂ))
//---------- ʕϐ`   
extern  char    gIsRunning;
extern  volatile int     gnAliveCnt;    // 0.1bŉZANNpX_m0NAŉ]Ɏg
extern  volatile DWORD     gnTimer2Cnt;    // Timer2荞݂Ƃ̃JEg,0.1b
extern  volatile int     gn100msCnt;
extern  int     gnTimer4Mode;
extern  volatile int     gninjstoppreiod;
extern  volatile int     gninjststartwait;
extern  volatile int     gninjststartangle;
extern  volatile int     gnignstoppreiod;
extern  volatile int     gnignstartwait;
extern  volatile int     gnignstartangle;
extern volatile DWORD gnLastCPlusT2Val;
extern IDLEDATA gidledata;
#define ADSAMPLING_UNIT 500
#define ADSAMPLING_PORTS 8
extern unsigned char gadresult[ADSAMPLING_UNIT * 2][ADSAMPLING_PORTS];
#define ADSAMPLINGBYTES ((ADSAMPLING_UNIT * ADSAMPLING_PORTS) / sizeof(char))
extern  volatile int  gidxadresult;
extern  volatile int     groundtime;         // 1]̃^C}[l
extern  volatile int     glastTDCtime;       // Ō̏㎀_łTMR2̒l
extern volatile char     gIsInputCycle;      // ݂zCTCNǂ
extern volatile int     gidxrpm;
extern  volatile char    gnanglenow;         // NNpX݈̌ʒuA30xPʂ
extern char     gCPlusOn;           // ݁ANNpX
extern char     gOInjOn;            // ݁AIWiCWFN^[ON̏ꍇP
extern  int     gnOinjstoppreiod;   // IWiCWFN^ ON->OFF܂ł̃^C
extern char     gOIgnOn;            // ݁AIWiIGNON̏ꍇ1
extern  int     gnOignstoppreiod;   // IWiIGN ON->OFF܂ł̃^C
extern  int     gac12Vresult;       // 12VdĎp
extern volatile int     gADOkayBank;        // ADϊĂoN 1 or 2, 0ȂAD,  rbgZ4 Ȃ΃oNPbN, 8Ȃ2bN
extern char     gOInjEnter;         // IWiCWFN^[2]ONɂȂƂ邩
extern char     gOIgnEnter;          // IWiIGN2]ONɂȂƂ邩
#define IsCPulsOn()  (gCPlusOn)    // NNpXオ蒆
extern  int     gErrorCode;         // O[oG[R[h
extern ALLTBL	gecudata;
extern UINT8    gIdxTbls[4][256];   // 臒l8rbgȂ̂ŁAYɕϊł悤e[u
extern  int     gAccelVal;        // 255 - min
extern volatile int gVaccumVal;
extern volatile int gWaitInterupt;  // ֎~INTԍ
extern volatile int gnLastBTDC;     // BTDC_ΊpxA0.1xP
extern volatile int gnAccelDelta;
extern volatile int gnKasokuAdd;    // ɒǉ鑝ʁB{lɑ΂p[Ze[WA0.1%P
extern volatile int gnKasokuSubVal;    // gnKasokuAdd 0.1bɌZl
extern volatile int gnAccelPumpSpan;

extern SAVEDATA gsavedata;          //  
extern ALLTBL deftable ;

extern volatile int gerror;
#define    SetErrorCode( nError)     (gerror = nError)
void ShowErrorLED(int nError);
#define ClearErrorCode()	(gerror = 0)	

    /* Provide C++ Compatibility */
    
#ifdef __cplusplus
}
#endif

#endif /* _VARDEF_H */

